<TeXmacs|1.0.1.1>

<style|article>

<\body>
  <name|>

  <\expand|make-title>
    <title|XDGtoQLF>

    <author|Daniele Pighin>
  </expand>

  <\abstract>
    XDGtoQLF  un software per la trasformazione di <em|XDG> (eXtended
    Dependency Graph) in <em|QLF> (Quasi Logical Form). Le regole da seguire
    per la conversione devono tenere conto del fatto che a documenti scritti
    in idiomi diversi corrispondono in genere XDG differenti e devono essere
    modificabili al runtime senza bisogno di agire sul codice sorgente del
    tool, che deve essere integrato all'interno di una cascata di moduli gi
    esistenti o in fase di costruzione.
  </abstract>

  <\expand|table-of-contents|toc>
    <vspace*|2fn><with|font series|<quote|bold>|math font
    series|<quote|bold>|font size|<quote|1.19>|Introduzione><value|toc-dots><pageref|toc-1><vspace|1fn>

    <vspace*|1fn><with|font series|<quote|bold>|math font
    series|<quote|bold>|1<space|2spc>Scopo del
    progetto><value|toc-dots><pageref|toc-2><vspace|0.5fn>

    1.1<space|2spc>XDG<value|toc-dots><pageref|toc-3>

    1.2<space|2spc>QLF<value|toc-dots><pageref|toc-4>

    1.3<space|2spc>XDG <with|mode|<quote|math>|\<longmapsto\>>
    QLF<value|toc-dots><pageref|toc-5>

    1.4<space|2spc>Vincoli progettuali<value|toc-dots><pageref|toc-6>

    <with|left margin|<quote|1.5fn>|1.4.1<space|2spc>Vincoli sulla capacit
    espressiva delle regole<value|toc-dots><pageref|toc-7>>

    <with|left margin|<quote|1.5fn>|1.4.2<space|2spc>Vincoli
    implementativi<value|toc-dots><pageref|toc-8>>

    <vspace*|2fn><with|font series|<quote|bold>|math font
    series|<quote|bold>|font size|<quote|1.19>|La soluzione proposta:
    XDGtoQLF><value|toc-dots><pageref|toc-9><vspace|1fn>

    <vspace*|1fn><with|font series|<quote|bold>|math font
    series|<quote|bold>|2<space|2spc>Una descrizione ad alto
    livello><value|toc-dots><pageref|toc-10><vspace|0.5fn>

    <vspace*|1fn><with|font series|<quote|bold>|math font
    series|<quote|bold>|3<space|2spc>Aspetti
    implementativi><value|toc-dots><pageref|toc-11><vspace|0.5fn>

    3.1<space|2spc>Tecnologie adottate<value|toc-dots><pageref|toc-12>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|XML<value|toc-dots><pageref|toc-13>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|Java<value|toc-dots><pageref|toc-14>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|XML
    <with|mode|<quote|math>|\<Longleftrightarrow\>> Java: <with|font
    shape|<quote|italic>|fr.ernstb.xmlcode><value|toc-dots><pageref|toc-15>>

    3.2<space|2spc>Algoritmi adottati<value|toc-dots><pageref|toc-16>

    <with|left margin|<quote|1.5fn>|3.2.1<space|2spc>Comportamento di alto
    livello del sistema<value|toc-dots><pageref|toc-17>>

    3.3<space|2spc>Organizzazione del filesystem<value|toc-dots><pageref|toc-18>

    3.4<space|2spc>Classi principali<value|toc-dots><pageref|toc-19>

    <with|left margin|<quote|1.5fn>|3.4.1<space|2spc>XDGtoQLFObject<value|toc-dots><pageref|toc-20>>

    <with|left margin|<quote|1.5fn>|3.4.2<space|2spc>XDGtoQLF<value|toc-dots><pageref|toc-21>>

    <with|left margin|<quote|1.5fn>|3.4.3<space|2spc>Rule<value|toc-dots><pageref|toc-22>>

    <with|left margin|<quote|1.5fn>|3.4.4<space|2spc>ListOfConstraints<value|toc-dots><pageref|toc-23>>

    <with|left margin|<quote|1.5fn>|3.4.5<space|2spc>Constraint<value|toc-dots><pageref|toc-24>>

    <with|left margin|<quote|1.5fn>|3.4.6<space|2spc>Substitution<value|toc-dots><pageref|toc-25>>

    <vspace*|2fn><with|font series|<quote|bold>|math font
    series|<quote|bold>|font size|<quote|1.19>|I file delle
    regole<label|regole>><value|toc-dots><pageref|toc-26><vspace|1fn>

    <vspace*|1fn><with|font series|<quote|bold>|math font
    series|<quote|bold>|4<space|2spc>Struttura di un file di
    regole><value|toc-dots><pageref|toc-27><vspace|0.5fn>

    4.1<space|2spc>Xml Schema Definition per i file delle
    regole<value|toc-dots><pageref|toc-28>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|Schema
    definition<value|toc-dots><pageref|toc-29>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
    <with|color|<quote|blue>|\<less\>rules\<gtr\>><value|toc-dots><pageref|toc-30>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
    <with|color|<quote|blue>|\<less\>constituents\<gtr\>> e
    <with|color|<quote|blue>|\<less\>icds\<gtr\>><value|toc-dots><pageref|toc-31>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
    <with|color|<quote|blue>|\<less\>rule\<gtr\>><value|toc-dots><pageref|toc-32>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
    <with|color|<quote|blue>|\<less\>constraints\<gtr\>><value|toc-dots><pageref|toc-33>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
    <with|color|<quote|blue>|\<less\>substitutions\<gtr\>><value|toc-dots><pageref|toc-34>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
    <with|color|<quote|blue>|\<less\>constraint\<gtr\>><value|toc-dots><pageref|toc-35>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
    <with|color|<quote|blue>|\<less\>substitution\<gtr\>><value|toc-dots><pageref|toc-36>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
    <with|color|<quote|blue>|\<less\>arguments\<gtr\>><value|toc-dots><pageref|toc-37>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
    <with|color|<quote|blue>|\<less\>argument\<gtr\>><value|toc-dots><pageref|toc-38>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|Chiusura della
    definizione<value|toc-dots><pageref|toc-39>>

    <vspace*|1fn><with|font series|<quote|bold>|math font
    series|<quote|bold>|5<space|2spc>Propriet, costanti ed espansione dei
    predicati mediante EuroWordNet><value|toc-dots><pageref|toc-40><vspace|0.5fn>

    5.1<space|2spc>Stringhe costanti<value|toc-dots><pageref|toc-41>

    5.2<space|2spc>Propriet<value|toc-dots><pageref|toc-42>

    5.3<space|2spc>Espansione dei predicati generati mediante
    EoroWordNet<value|toc-dots><pageref|toc-43>

    <with|left margin|<quote|1.5fn>|5.3.1<space|2spc>Il concetto di
    <with|font shape|<quote|italic>|espansione><value|toc-dots><pageref|toc-44>>

    <with|left margin|<quote|1.5fn>|5.3.2<space|2spc>Parole chiave per
    l'espansione dei predicati<value|toc-dots><pageref|toc-45>>

    <vspace*|1fn><with|font series|<quote|bold>|math font
    series|<quote|bold>|6<space|2spc>I constraint><value|toc-dots><pageref|toc-46><vspace|0.5fn>

    6.1<space|2spc>Due livelli di definizione: regole e
    sostituzioni<value|toc-dots><pageref|toc-47>

    6.2<space|2spc>Constraint predefiniti<label|constraint
    predefiniti><value|toc-dots><pageref|toc-48>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|equals(a,b)<value|toc-dots><pageref|toc-49>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|isSet(a)<value|toc-dots><pageref|toc-50>>

    <with|left margin|<quote|6fn>|font size|<quote|0.84>|matchesRegExp(a,b)<value|toc-dots><pageref|toc-51>>

    6.3<space|2spc>Negazione dei constraint: forme condizionali per i file
    delle regole<label|negazione dei constraint><value|toc-dots><pageref|toc-52>
  </expand>

  <format|page break><chapter|Introduzione>

  <section|Scopo del progetto>

  Lo scopo di questo progetto di laboratorio  stato quello di trovare una
  forma conveniente e sufficientemente versatile per convertire un grafo
  espresso mediante il formalismo <em|XDG> (eXtended Dependency Graph) in un
  grafo equivalente<\footnote>
    L'equivalenza  limitata ai nodi e agli archi del grafo che si intende
    trasformare.
  </footnote> espresso sotto forma di <em|QLF> (Quasi Logical Form).

  Entrambi i formalismi mirano a rappresentare le relazioni che intercorrono
  tra le <em|parti del discorso> (<em|POS>, Part Of Speech) di un testo
  analizzato. Conseguentemente, due XDG generati a partire da due testi
  equivalenti espressi in lingue differenti avranno una diversa composizione,
  essendo dissimili le POS<\footnote>
    Pi precisamente  l'insieme di <em|POStag>, cio le etichette usate per
    identificare i nodi, ad essere language-dependent.
  </footnote> di testi espressi in lingue diverse (si pensi ad esempio
  all'assenza del plurale per gli aggettivi in inglese).

  Ne consegue che qualsiasi strumento che debba operare su un XDG deve tenere
  conto della lingua del documento di partenza al fine di interpretarne
  correttamente il significato, e che la QLF generata da un XDG ne sia
  inevitabilmente influenzata.

  <subsection|XDG>

  Nel formalismo XDG, un nodo pu essere un <em|constituent> (costituente) o
  un <em|icd> (inter constituent dependency). Un icd  legato a due
  costituenti, distinti in un nodo di origine (arco etichettato con
  <em|From>) e in un nodo di destinazione (arco etichettato con <em|To>).

  A sua volta, anche un <em|constituent> pu essere di tue tipi: <em|simple>
  e <em|complex>, nel qual caso due archi, etichettati rispettivamente con
  <em|Head> e <em|Gov>, lo collegano ad altrettanti costituenti semplici o
  complessi.

  La struttura di un XDG pu essere esplicata dal grafo in figura
  (<reference|grafo XDG>).

  <\expand|big-figure|<postscript|schemaXDG.eps|*3/8|*3/8||||>>
    Struttura schematica di un grafo XDG.

    Con <em|I> sono indicati gli Icd, con <em|CC> i costituenti complessi e
    con <em|SC> i costituenti semplici.

    <em|H> e <em|G> sono le relazioni Head e Gov che legano le parti di un
    costituente complesso allo stesso.

    L'Head e il Gov di un costituente semplice sono lo stesso
    costituente.<label|grafo XDG>
  </expand>

  <subsection|QLF>

  I nodi di grafo QLF possono essere <em|predicati> Prolog o <em|argomenti>
  di questi predicati. Un predicato pu essere applicato a due argomenti
  oppure ad uno solo. L'applicazione di un predicato ad i rispettivi
  argomenti  rappresentata da un arco del grafo.

  Un argomento pu essere <em|semplice>, oppure pu essere un predicato a sua
  volta, ma questa ricorsivit pu avere al massimo un livello, ovvero sia:
  se un argomento di un predicato  un altro predicato, gli argomenti di
  quest ultimo saranno senz'altro semplici. La figura (<reference|grafo QLF>)
  presenta 2 casi di grafo QLF, di cui uno non valido (caso B) a causa
  dell'eccessivo annidamento di un argomento di tipo non semplice.

  <\expand|big-figure|<postscript|schemaQLF.eps|*3/8|*3/8||||>>
    Esempi di grafi QLF.

    Con <em|P> sono indicati i predicati, mentre gli argomenti sono indicati
    con <em|A>.

    Il grafo B non  ammissibile poich presenta un predicato annidato troppo
    in profondit.<label|grafo QLF>
  </expand>

  <subsection|XDG <with|mode|math|\<longmapsto\>> QLF>

  La trasformazione di un XDG in QLF non  immediata, non essendovi
  corrispondenza biunivoca tra costituenti e icd da una parte e predicati ed
  argomenti dall'altra.

  Piuttosto,  vero in genere che ogni icd e ogni costituente vengono
  tradotti in pi di un predicato Prolog con i rispettivi argomenti. Quali
  siano i predicati e quali gli argomenti, dipende dalle propriet del grafo
  di partenza e da quelle dell'elemento (icd o costituente) in esame.

  <subsection|Vincoli progettuali>

  Segue un elenco dei vincoli che il software deve soddisfare:

  <subsubsection|Vincoli sulla capacit espressiva delle regole>

  <\expand|itemize-arrow>
    <item>Per ogni lingua deve essere possibile esprimere un set di regole
    indipendente;

    <item>Ogni regola deve essere attivata se e solo se l'elemento che si sta
    analizzando risponde ad uno o pi vincoli riguardanti una o pi di una
    sue propriet;

    <item>Dato un insieme di vincoli, deve essere possibile indicare se
    l'elemento deve rispondere a tutti i vincoli o solo ad alcuni di essi;

    <item>Deve essere possibile esprimere forme condizionali per le regole,
    del tipo:

    <\code>
      <\verbatim>
        if (...) {...}

        else if (...) {...}

        else {...}
      </verbatim>
    </code>

    <item>Deve essere possibile mappare qualsiasi elemento di un XDG in
    qualsiasi forma ammessa per un predicato Prolog;

    <item>Ogni elemento XDG deve poter essere mappato in un numero variabile
    di predicati Prolog validi;

    <item>Devono essere contemplati i casi in cui una regola debba essere
    iterata in funzione delle possibili espansioni su <em|EWN> (EuroWordNet)
    di uno o entrambi i suoi argomenti o del nome del predicato.
  </expand>

  <subsubsection|Vincoli implementativi>

  <\expand|itemize-arrow>
    <item>Le regole non devono essere hard-coded nel software: deve essere
    possibile aggiungerle, rimuoverle e modificarle senza che sia necessario
    correggerlo e/o ricompilarlo;

    <item>Il tool deve essere integrato all'interno di una cascata di moduli
    gi definiti. Il formato dei dati in ingresso e quello dei dati in uscita
     pertanto definito a priori e non negoziabile;
  </expand>

  <chapter|La soluzione proposta: XDGtoQLF>

  <section|Una descrizione ad alto livello>

  XDGtoQLF  l'insieme di una parte procedurale (il <em|programma>) ed un
  numero variabile di file in cui sono definite le regole di conversione, uno
  per ogni lingua che  supportata dal sistema <em|CHAOS>, responsabile della
  generazione degli XDG.

  Al momento dell'esecuzione, il programma importa un file di regole indicato
  dal programmatore<\footnote>
    Automatizzare la scelta del file di regole da impiegare sarebbe stato
    possibile e di facile implementazione, essendo sufficienti allo scopo la
    definizione di una convenzione per i nomi dei file e la determinazione
    della lingua usata per l'XDG (analizzando il documento di origine).\ 

    La \ soluzione adottata mira ad aumentare la flessibilit di utilizzo del
    tool, permettendo alle regole di essere collocate in qualunque parte del
    filesystem.

    In questo modo  anche possibile avere non solo un file per lingua, ma
    anche pi file per la stessa lingua (da usare ad esempio per testare un
    certo subset di regole).

    Il caricamento automatico del file delle regole, qualora fosse una
    caratteristica desiderabile, pu essere comunque ottenuto semplicemente
    facendo precedere il tool da un modulo che determini il file da adoperare
    e ne passi il path a XDGtoQLF.<label|indicazione esplicita del file delle
    regole>
  </footnote> che utilizza per inizializzare in modo dinamico la gerarchia
  degli oggetti responsabili delle operazioni di trasformazione.

  Le regole vengono quindi sovrapposte al grafo in ingresso per produrre il
  risultato\ 

  <section|Aspetti implementativi>

  <subsection|Tecnologie adottate>

  <paragraph|XML>

  Per la formalizzazione delle regole di conversione ho deciso di optare per
  l'XML (eXtended Markup Language). XML offre diversi vantaggi; tra questi:

  <\expand|itemize-arrow>
    <item>nasce per conservare informazioni strutturate;

    <item> estendibile a piacimento ed estremamente versatile;

    <item> human-readable e tutti i linguaggi di programmazione moderni
    offrono delle API per la manipolazione di file XML;

    <item>se associato ad un DTD o un XSD, un documento deve necessariamente
    conformarsi ad una data struttura e rispettare certe regole;

    <item>un file XML pu essere composto con tool appositi oppure con
    qualsiasi editor di testi;

    <item> self-explainatory;

    <item> uno standard <em|de iure> e <em|de facto>;
  </expand>

  <paragraph|Java>

  La scelta di Java per la parte procedurale del software  stata dettata
  dalla necessit di integrare il tool all'interno di un'architettura gi
  esistente sviluppata con questo linguaggio.

  Inoltre, sempre per problemi di integrazione  stata utilizzato un <em|jdk>
  relativamente datato (1.2.2). Per sopperire alla mancanza di alcune
  funzionalit in questa versione della piattaforma <em|Sun>, ho dovuto usare
  librerie esterne (ad esempio il pacchetto <em|jregex> per la gestione delle
  espressioni regolari).\ 

  <paragraph|XML <with|mode|math|\<Longleftrightarrow\>> Java:
  <em|fr.ernstb.xmlcode>>

  Per far comunicare le due tecnologie ho usato un package
  (<em|fr.ernstb.xmlcode>) che permette di serializzare/deserializzare
  oggetti Java in/da file XML. Questa soluzione, diversamente da altre,
  realizza la possibilit di mappare l'insieme di regole su una gerarchia di
  oggetti in modo completamente automatico, agevolando la scrittura di codice
  pi rispondente ai principi dell'OOD.

  Per contro, <em|xmlcode>  uno strumento non perfettamente maturo e manca
  di certe caratteristiche che sarebbero tornate piuttosto utili. Queste
  carenze hanno viziato alcuni aspetti del software; in particolare, mi hanno
  costretto ad adottare per il file delle regole una struttura pi complessa
  e meno intuitiva del dovuto, e a definire alcune classi del sistema
  diversamente da come avrei fatto se non avessi avuto questo vincolo.

  In particolare:

  <\expand|itemize-arrow>
    <item>tutte le classi sono state definite <em|public> per renderne
    possibile la serializzazione/deserializzazione, e cos tutti i campi che
    devono essere importati dai file di regole, anche quelli che avrei
    altrimenti preferito definire <em|private> o <em|protected>.

    <item>xmlcode non permette di mappare pi entit sulla stessa classe.
    Questo mi ha costretto ad aggiungere classi uguali ma col nome diverso
    per rappresentare strutture dati uguali identificate nel file delle
    regole da diverse entit.

    E' ad esempio il caso delle entit <verbatim|\<less\>icds\<gtr\>> e
    <verbatim|\<less\>constituents\<gtr\>>, che invece di essere entrambe
    mappate sulla classe <verbatim|ListOfRules> lo sono su due classi
    distinte che di questa sono l'estensione (<verbatim|ListOfIcdsRules> e
    <verbatim|ListOfConstituentsRules>).

    <item>xmlcode non permette di mappare classi che estendano
    <verbatim|Vector> su entit in un file xml; questo mi ha costretto a
    dichiare alcune classi cos:

    <\code>
      <\verbatim>
        <with|font size|0.84|public class MyClass { ... Vector v; ... }>
      </verbatim>
    </code>

    piuttosto che cos (come sarebbe stato naturale):

    <\code>
      <with|font size|0.84|<verbatim|public class MyClass extends Vector {
      ... }>>
    </code>
  </expand>

  Queste imperfezioni dello strumento adoperato giustificano l'eccessiva
  complessit e la ridondanza presenti nella gerarchia delle classi.

  <subsection|Algoritmi adottati>

  <subsubsection|Comportamento di alto livello del sistema>

  Siano <strong|T> il testo da processare, <strong|Q> la stringa da
  restituire con la lista dei predicati generati.

  <\expand|enumerate-numeric>
    <item>sia <strong|P> l'insieme dei paragrafi di cui  composto <strong|T>

    <item>per ogni paragrafo <em|p> in <strong|P>

    <\expand|enumerate-numeric>
      <item>sia <strong|X> l'insieme degli XDG estratti da <em|p>

      <item>per ogni XDG <em|x> in <strong|X>

      <\expand|enumerate-numeric>
        <item>siano <strong|I> l'insieme degli Icd in <em|x>, e <strong|C>
        quello dei constituent

        <item>per ogni icd <em|i> in <strong|I>

        <\expand|enumerate-numeric>
          <item>sia <strong|R> l'insieme delle regole di conversione per gli
          icd

          <item>per ogni regola <em|r> in <strong|R>

          <\expand|enumerate-numeric>
            <item>se <em|i> soddisfa i constraint di <em|r>

            <\expand|enumerate-numeric>
              <item>sia <strong|S> l'insieme di sostituzioni per la regola
              <em|r>

              <item>per ogni sostituzione <em|s> in <strong|S>

              <\enumerate>
                <item>se <em|i> soddisfa i constraint di <em|s>

                <\expand|enumerate-numeric>
                  <item>sia <em|q> il risultato della sostituzione

                  <item>aggiungi <em|q> a <strong|Q>
                </expand>
              </enumerate>
            </expand>
          </expand>
        </expand>

        <item>per ogni constituent <em|c> in <strong|C>

        <\expand|enumerate-numeric>
          <item>sia <strong|R> l'insieme delle regole di conversione per i
          costituenti

          <item>per ogni regola <em|r> in <strong|R>

          <\expand|enumerate-numeric>
            <item>se <em|c> soddisfa i constraint di <em|r>

            <\expand|enumerate-numeric>
              <item>sia <strong|S> l'insieme di sostituzioni per la regola
              <em|r>

              <item>per ogni sostituzione <em|s> in <strong|S>

              <\enumerate>
                <item>se <em|c> soddisfa i constraint di <em|s>

                <\expand|enumerate-numeric>
                  <item>sia <em|q> il risultato della sostituzione

                  <item>aggiungi <em|q> a <strong|Q>
                </expand>
              </enumerate>
            </expand>
          </expand>
        </expand>
      </expand>
    </expand>
  </expand>

  <subsection|Organizzazione del filesystem>

  Tutte le classi di cui  composto il tool sono state organizzate
  all'interno del package <em|it.uniroma2.XDGtoQLF>.

  Per i file delle regole si  deciso di averne uno per ogni lingua da
  trattare. Inoltre si  deciso di non vincolare la loro collocazione,
  lasciando all'utente la responsabilit di indicare il path del file da
  adoperare per la conversione<\footnote>
    Vedasi nota (<reference|indicazione esplicita del file delle regole>).
  </footnote>.

  <subsection|Classi principali>

  In questa sezione si descrivono ad alto livello le classi principali che
  compongono il sistema.

  Di queste, solo <verbatim|XDGtoQLF> deve essere usata direttamente dal
  programmatore che intendesse operare una conversione.

  Le altre classi sono descritte a scopo di riuso e per completezza, ma la
  conoscenza delle funzionalit che mettono a disposizione non  necessaria
  al fine della trasformazione dei grafi.

  <subsubsection|XDGtoQLFObject><label|XDGtoQLFObject>

  E' una classe di utilit general purpose. In particolare, contiene un
  metodo statico (<verbatim|getFieldValue>) che  cardinale per il
  funzionamento del tool e permette l'accesso alle propriet di gerarchie
  complesse di oggetti.

  Dalla documentazione in formato JavaDoc per la classe:

  <\code>
    <with|font size|0.84|<\verbatim>
      <strong|<with|font size|1|public static Object getFieldValue(Object
      obj, String fieldName):>>
    </verbatim>>
  </code>

  <\description>
    Extracts a given property (or "field value", or "data memebr") from an
    object. It is conceived to dig into an object properties hierarchy to
    extract also deep nested and/or complex properties. For example, a call
    to <verbatim|XDGtoQLFObject(myObj, "a:b:c")> would return the property
    <verbatim|c> from the object <verbatim|b>, which is a property of the
    <verbatim|a> object, which is in turn a a property of the
    <verbatim|myObj> object.

    <\description>
      <expand|item*|<with|font series|bold|Parameters:>>

      <expand|item*|><verbatim|obj> - the object from which we want a
      property to be extracted.

      <expand|item*|><verbatim|fieldName> - the name of the field that we
      want to extract from the object. A syntax like "a:b:c" is admitted,
      being respectively

      <\itemize>
        <item><verbatim|a> a property of <verbatim|obj>

        <item><verbatim|b> a property of <verbatim|a>

        <item><verbatim|c> a property of <verbatim|b>
      </itemize>

      and you can go as deep as you want.\ 

      <expand|item*|>If a property by a given name (say:
      <verbatim|myPropertyName>) can't be found in the hierarcy, because it
      doesn't exist, or if it can't be accessed having been declared private
      or protected, than the method <verbatim|getMyPropertyName()> is called
      on the previous element of the hierarcy.\ 

      Moreover, you can access array, vector and method-returned properties:

      <\itemize>
        <item><with|font series|bold|<verbatim|a:b:get(5)>> would return the
        fifth element of the vector <verbatim|b>, which is a property of
        <verbatim|a>, which is in turn a property of the object passed as the
        first parameter

        <item><with|font series|bold|<verbatim|a:b[5]>> would return the
        fifth element of the array <verbatim|b>, which is a property of
        <verbatim|a>, which is in turn a property of the object passed as the
        first parameter

        <item><with|font series|bold|<verbatim|a:b:performMethod()>> would
        return the same as a call to the method <verbatim|performMethod()> on
        the object <verbatim|b>, which is a property of <verbatim|a>, which
        is in turn a property of the object passed as the first parameter.

        Please, note that <with|font series|bold|you can only call methods
        without arguments>.
      </itemize>

      <expand|item*|<with|font series|bold|Returns:>>the object addressed by
      the property hierarcy on the passed <verbatim|obj> parameter,
      <verbatim|null> on failure (or if the property <with|font
      shape|italic|is> null or was badly addressed).
    </description>
  </description>

  \;

  <subsubsection|XDGtoQLF>

  La classe <em|XDGtoQLF>  l'interfaccia con il sistema in cui il tool 
  inserito.

  Il suo compito  quello di accettare una struttura dati XDG in
  ing<paragraphsign>esso e produrre una corripsondente QLF in modo
  completamente trasparente per l'utente.

  <subsubsection|Rule>

  La classe <em|Rule>  responsabile per l'applicazione di una regola di
  sostituzione.

  Verifica che l'oggetto esaminato verifichi i constraint della regola e
  gestisce l'elaborazione delle sostituzioni e la produzione dei risultati.

  E' il tramite tra l'interfaccia con il sistema (la classe <em|XDGtoQLF>) e
  le classi di controllo che materialmente producono le trasformazioni.

  <subsubsection|ListOfConstraints>

  La classe <dfn|ListOfConstraints> si occupa di gestire un elenco di
  constraint, si a livello di una regola che a livello di una sostituzione.

  <subsubsection|Constraint>

  La classe <em|Constraint> verifica che un oggetto soddisfi o meno un dato
  vincolo.

  Contiene le definizioni per i constraint predefiniti e il codice che i
  constraint attivano.

  Se si intendesse aggiungere dei constraint predefiniti, l'unica classe da
  modificare sarebbe questa.

  <subsubsection|Substitution>

  La classe substitution fornisce gli strumenti per operare una sostituzione.

  <chapter|I file delle regole<label|regole>>

  <section|Struttura di un file di regole>

  <subsection|Xml Schema Definition per i file delle regole>

  Di seguito viene riportato l' <em|XSD> (Xml Schema Definition) usato per la
  validazione di un file di regole. Il file  stato commentato a scopo
  illustrativo.

  <paragraph|Schema definition>

  \;

  <\with|color|blue>
    \<less\>?xml version="1.0" encoding="UTF-8" ?\<gtr\>

    \<less\>schema xmlns="http://www.w3.org/2001/10/XMLSchema"\<gtr\>
  </with>

  \;

  <paragraph|Entit <with|color|blue|\<less\>rules\<gtr\>>>

  <\description>
    <expand|item*|descrizione:>\<less\>rules\<gtr\>  la radice di ogni file
    di regole; pertanto, ogni file di regole pu contenerne una ed una sola.

    <expand|item*|attributi:>-

    <expand|item*|contiene:>

    <\expand|itemize-arrow>
      <item>al pi una entit di tipo \<less\>icds\<gtr\>

      <item>al pi una entit di tipo \<less\>constituents\<gtr\>
    </expand>

    <expand|item*|>
  </description>

  <\with|color|blue>
    \ \ \ \ \ \ \ \<less\>element name="rules"\<gtr\>

    \ \ \<less\>complexType\<gtr\>

    \ \ \ \<less\>sequence\<gtr\>

    \ \ \ \ \<less\>element ref="constituents" minOccurs="0" maxOccurs="1"
    /\<gtr\>

    \ \ \ \ \<less\>element ref="icds" minOccurs="0" maxOccurs="1" /\<gtr\>

    \ \ \ \<less\>/sequence\<gtr\>

    \ \ \<less\>/complexType\<gtr\>

    \ \<less\>/element\<gtr\>
  </with>

  \;

  <paragraph|Entit <with|color|blue|\<less\>constituents\<gtr\>> e
  <with|color|blue|\<less\>icds\<gtr\>>>

  <\description>
    <expand|item*|descrizione:>\<less\>constituents\<gtr\> contiene le regole
    di conversione da applicare ai costituenti, \<less\>icds\<gtr\> quelle da
    applicare agli icd.

    <expand|item*|attributi:>-

    <expand|item*|contengono:>almeno un'entit di tipo \<less\>rule\<gtr\>
  </description>

  \;

  <\with|color|blue>
    \<less\>element name="constituents"\<gtr\>

    \ \ \<less\>complexType\<gtr\>

    \ \ \ \<less\>element ref="rule" minOccurs="1" maxOccurs="unbounded"
    /\<gtr\>

    \ \ \<less\>/complexType\<gtr\>

    \ \<less\>/element\<gtr\>

    \;

    \ \<less\>element name="icds"\<gtr\>

    \ \ \<less\>complexType\<gtr\>

    \ \ \ \<less\>element ref="rule" minOccurs="1" maxOccurs="unbounded"
    /\<gtr\>

    \ \ \<less\>/complexType\<gtr\>

    \ \<less\>/element\<gtr\>
  </with>

  \;

  <paragraph|Entit <with|color|blue|\<less\>rule\<gtr\>>>

  <\description>
    <expand|item*|descrizione:>una \<less\>rule\<gtr\>  la rappresentazione
    di una regola di conversione. Una regola di conversione  l'insieme delle
    sostituzioni da eseguire nel caso in cui l'elemento in esame (icd o
    costituente) verifichi certi presupposti (vincoli).

    <expand|item*|attributi:><em|description>  una stringa che pu essere
    usata per descrivere in linguaggio naturale la funzione della regola. Pu
    essere omessa, serve solo a rendere pi leggibile il file.

    <expand|item*|contiene:>

    <\expand|itemize-arrow>
      <item>0 o 1 entit di tipo \<less\>constraints\<gtr\>

      <item>una o pi entit di tipo \<less\>substitution\<gtr\>
    </expand>
  </description>

  \;

  <\with|color|blue>
    \ \<less\>element name="rule"\<gtr\>

    \ \ \<less\>complexType\<gtr\>

    \ \ \ \<less\>sequence\<gtr\>

    \ \ \ \ \<less\>element ref="constraints" minOccurs="0" maxOccurs="1"
    /\<gtr\>

    \ \ \ \ \<less\>element ref="substitutions" minOccurs="1" maxOccurs="1"
    /\<gtr\>

    \ \ \ \<less\>/sequence\<gtr\>

    \ \ \ \<less\>attribute name="description" type="string"
    use="optional"/\<gtr\>

    \ \ \<less\>/complexType\<gtr\>

    \ \<less\>/element\<gtr\>
  </with>

  \;

  <paragraph|Entit <with|color|blue|\<less\>constraints\<gtr\>>>

  <\description>
    <expand|item*|descrizione:>\<less\>constraints\<gtr\>  un contenitore di
    \<less\>constraint\<gtr\>.

    <expand|item*|attributi:>l'attributo <em|matches> pu assumere due
    valori: <em|any> oppure <em|all> (predefinito). <em|matches="any"> indica
    che basta che uno dei \<less\>constraint\<gtr\> contenuti sia soddisfatto
    per attivare le sostituzioni; <em|matches="all"> indica che tutti i
    constraint devono essere verificati affinche le sostituzioni siano
    attivate.

    <expand|item*|contiene:>1 o pi entit di tipo \<less\>constraint\<gtr\>
  </description>

  \;

  <\with|color|blue>
    \ \<less\>element name="constraints"\<gtr\>

    \ \ \<less\>complexType\<gtr\>

    \ \ \ \<less\>element ref="constraint" minOccurs="1"
    maxOccurs="unbounded" /\<gtr\>

    \ \ \ \ \<less\>attribute name="match" use="optional" type="string"
    default="all"\<gtr\>

    \ \ \ \ \ \<less\>simpleType\<gtr\>

    \ \ \ \ \ \ \<less\>restriction\<gtr\>

    \ \ \ \ \ \ \ \<less\>enumeration value="any"/\<gtr\>

    \ \ \ \ \ \ \ \<less\>enumeration value="all"/\<gtr\>

    \ \ \ \ \ \ \<less\>/restriction\<gtr\>

    \ \ \ \ \ \<less\>/simpleType\<gtr\>

    \ \ \ \ \<less\>/attribute\<gtr\>

    \ \ \<less\>/complexType\<gtr\>

    \ \<less\>/element\<gtr\>
  </with>

  \;

  <paragraph|Entit <with|color|blue|\<less\>substitutions\<gtr\>>>

  <\description>
    <expand|item*|descrizione:>\<less\>substitutions\<gtr\>  un contenitore
    di \<less\>substitution\<gtr\>.

    <expand|item*|attributi:>-

    <expand|item*|contiene:>1 o pi entit di tipo
    \<less\>substitution\<gtr\>
  </description>

  \;

  <\with|color|blue>
    \ \<less\>element name="substitutions"\<gtr\>

    \ \ \<less\>complexType\<gtr\>

    \ \ \ \<less\>element ref="substitution" minOccurs="1"
    maxOccurs="unbounded" /\<gtr\>

    \ \ \<less\>/complexType\<gtr\>

    \ \<less\>/element\<gtr\>
  </with>

  \;

  <paragraph|Entit <with|color|blue|\<less\>constraint\<gtr\>>>

  <\description>
    <expand|item*|descrizione:>un \<less\>constraint\<gtr\>  una
    pseudo-funzione che esprime un vincolo da soddisfare per l'attivazione di
    certe sostituzioni. Una entit \<less\>constraint\<gtr\> figlia di una
    \<less\>rule\<gtr\> definisce un vincolo che condiziona l'attivazione di
    tutte le sostituzioni contenute in quella regola; se figlia di una
    \<less\>substitution\<gtr\> il vincolo condiziona l'attivazione della
    sola sostituzione.

    <expand|item*|argomenti:>

    <expand|item*|contiene:>una stringa in un formato predefinito. I valori
    ammessi sono:

    <\expand|itemize-arrow>
      <item><em|isSet([a])>, che risulta soddisfatto quando la propriet
      <em|a> dell'oggeto in esame esiste,  accessibile e non nulla;

      <item><em|equals(a,b)>, che risulta soddisfatto quando <em|a> e <em|b>,
      che possono essere propriet o stringhe costanti, sono uguali;

      <item><em|matchesRegExp([a],'b')>, soddisfatto quando la propriet
      dell'oggetto indicata con <em|a> soddisfa l'espressione regolare
      rappresentata dal pattern indicato con <em|b>.
    </expand>
  </description>

  \ 

  <\with|color|blue>
    \<less\>element name="constraint" type="string"\<gtr\>

    \ \ \<less\>simpleType\<gtr\>

    \ \ \ \<less\>restriction\<gtr\>

    \ \ \ \ \<less\>pattern value="\\s*!?(isSet\|equals\|matchesRegExp).*"/\<gtr\>

    \ \ \ \<less\>/restriction\<gtr\>

    \ \ \<less\>/simpleType\<gtr\>

    \ \<less\>/element\<gtr\>
  </with>

  \;

  <paragraph|Entit <with|color|blue|\<less\>substitution\<gtr\>>>\ 

  <\description>
    <expand|item*|descrizione:>una \<less\>substitution\<gtr\>  una
    sostituzione da eseguire, e rappresenta la struttura di un predicato
    prolog. Una sostituzione  attivata se sono verificati sia i constraint a
    livello della regola, sia quelli definiti all'interno della stessa
    sostituzione.

    <expand|item*|attributi:>-

    <expand|item*|contiene:>

    <\expand|itemize-arrow>
      <item>una entit di tipo \<less\>tag\<gtr\>, che contiene una stringa
      che rappresenta il nome del predicato prolog

      <item>0 o 1 entit di tipo \<less\>constraints\<gtr\>

      <item>una entit di tipo \<less\>arguments\<gtr\>
    </expand>
  </description>

  \;

  <\with|color|blue>
    \<less\>element name="substitution"\<gtr\>

    \ \ \<less\>complexType\<gtr\>

    \ \ \ \<less\>sequence\<gtr\>

    \ \ \ \ \<less\>element ref="tag" minOccurs="1" maxOccurs="1"
    type="string" /\<gtr\>

    \ \ \ \ \<less\>element ref="constraints" minOccurs="0" maxOccurs="1"
    /\<gtr\>

    \ \ \ \ \<less\>element ref="arguments" minOccurs="1" maxOccurs="1"
    /\<gtr\>

    \ \ \ \<less\>/sequence\<gtr\>

    \ \ \<less\>/complexType\<gtr\>

    \ \<less\>/element\<gtr\>
  </with>

  \;

  <paragraph|Entit <with|color|blue|\<less\>arguments\<gtr\>>>

  <\description>
    <expand|item*|descrizione:>\<less\>arguments\<gtr\>  un contenitore di
    \<less\>argument\<gtr\>.

    <expand|item*|attributi:>-

    <expand|item*|contiene:>1 o 2 entit di tipo \<less\>argument\<gtr\>
  </description>

  \ 

  <\with|color|blue>
    \<less\>element name="arguments"\<gtr\>

    \ \ \<less\>complexType\<gtr\>

    \ \ \ \<less\>element ref="argument" minOccurs="1" maxOccurs="2" /\<gtr\>

    \ \ \<less\>/complexType\<gtr\>

    \ \<less\>/element\<gtr\>
  </with>

  \;

  <paragraph|Entit <with|color|blue|\<less\>argument\<gtr\>>>

  <\description>
    <expand|item*|descrizione:>un \<less\>argument\<gtr\> rappresenta
    l'argomento di un predicato prolog. L'argomento pu essere di tipo
    <em|semplice> (una stringa) oppure <em|complesso>, nel qual caso
    l'argomento  esso stesso un predicato prolog. La composizione di un
    \<less\>argument\<gtr\>  simile a quella di una
    \<less\>substitution\<gtr\>, con le seguenti differenze:

    <\expand|itemize-arrow>
      <item>un'entit \<less\>argument\<gtr\> non pu contenere un'entit
      \<less\>constraint\<gtr\>

      <item>un'entit \<less\>argument\<gtr\> pu non contenere un'entit
      \<less\>arguments\<gtr\>, nel qual caso rappresenta un argoment odi
      tipo semplice
    </expand>

    <expand|item*|attributi:>-

    <expand|item*|contiene:>

    <\expand|itemize-arrow>
      <item>un'entit di tipo \<less\>tag\<gtr\>, che  una stringa che pu
      rappresentare l'argomento di un predicato prolog (nel caso di argomento
      semplice) oppure il nome di un predicato (nel caso di argomento
      complesso)

      <item>0 o 1 entit di tipo \<less\>arguments\<gtr\>; nel 1<degreesign>
      caso l'argomento rappresentato  di tipo semplice, nel 2<degreesign>
      complesso
    </expand>
  </description>

  \ 

  <\with|color|blue>
    \<less\>element name="argument"\<gtr\>

    \ \ \<less\>complexType\<gtr\>

    \ \ \ \<less\>sequence\<gtr\>

    \ \ \ \ \<less\>element ref="tag" minOccurs="1" maxOccurs="1"
    type="string"/\<gtr\>

    \ \ \ \ \<less\>element ref="arguments" minOccurs="0" maxOccurs="1"
    /\<gtr\>

    \ \ \ \<less\>/sequence\<gtr\>

    \ \ \<less\>/complexType\<gtr\>

    \ \<less\>/element\<gtr\>
  </with>

  \;

  <paragraph|Chiusura della definizione>

  \;

  <with|color|blue|\<less\>/schema\<gtr\>>

  <section|Propriet, costanti ed espansione dei predicati mediante
  EuroWordNet>

  <\subsection>
    Stringhe costanti
  </subsection>

  Una stringa costante viene inserita all'interno di apici (ad esempio,
  <verbatim|'PP_PP'>  una stringa costante).

  <subsection|Propriet>

  Una propriet viene indicata attraverso l'uso di parentesi quadre
  (<verbatim|[]>).

  Una propriet  sempre relativa all'oggetto in esame: questo vuol dire che
  all'interno dei tag <verbatim|\<less\>icds\<gtr\>\<less\>/icds\<gtr\>> ogni
  riferimento ad una propriet  da intendersi relativamente al particolare
  icd a cui sta venendo applicata una data regola.

  All'interno delle parentesi quadre  possibile specificare anche propriet
  annidate in profondit nella struttura dati rappresentata dall'oggetto; il
  formato ammissibile per una propriet  esattamente lo stesso ammesso per
  il secondo argomento del metodo <verbatim|XDGtoQLF.getFieldValue>.

  Esempi validi di propriet sono ad esempio:

  <\expand|itemize-minus>
    <\with|font size|0.84>
      <item><verbatim|[Gov:LexHandleSequence:lastElement():TokConstVect:get(0):TokStart]>

      <item><verbatim|[From:Gov:Id]>

      <item><verbatim|[To:Head:Surfac<em|>e]>
    </with>
  </expand>

  <subsection|Espansione dei predicati generati mediante EoroWordNet>

  <subsubsection|Il concetto di <em|espansione>>

  Alcuni predicati richiedono di essere espansi mediante EuroWordNet. Con
  <em|espansione> si definisce l'operazione che consiste nel generare una
  molteplicit di predicati simili a partire da un predicato di partenza. La
  struttura (cio, il numero di argomenti ed il loro tipo, la tipologia del
  <em|label> etc.) dei predicati <em|espansi> dipende da quella del predicato
  di partenza, mentre il numero di <em|espansioni> dipende dal numero di
  <em|SynSet> che fanno capo ad una data forma lemmatizzata e al modo in cui
  le possibili espansioni devono essere ricombinate tra di loro.

  <subsubsection|Parole chiave per l'espansione dei predicati>

  Per attivare la ricerca di espansioni per un dato predicato su EWN sono
  state definite due parole chiave:

  <\description>
    <expand|item*|<verbatim|@EWNCODE:>>espande in tutti i possibili codici di
    SynSet identificabili su EWN per un dato termine;

    <expand|item*|<verbatim|@EWNEID:>>espande in tanti identificativi (da 0 a
    n) quanti sono i synset per un dato termine.
  </description>

  Ad esempio, un'espansione del predicato <verbatim|@EWNCODE(e65_@EWNEID)>,
  supposto che i SynSet identificati a partire dalla forma lemmatizzata del
  costituente con <em|Id=65> siano <verbatim|{123451,123452,123453}>,
  genererebbe i predicati: <verbatim|123451(e65_0), 123452(e65_1),
  123453(e65_2)>.

  Per i predicati da espandere sono ammesse solo tre forme:

  <\expand|enumerate-roman>
    <item>predicati nella forma <verbatim|@EWNCODE(*@EWNEID)>

    <item>predicati nella forma <verbatim|*(*@EWNEID, *@EWNEID)>

    <item>predicati nella forma <verbatim|*(*@EWNEID, *)>
  </expand>

  La limitazione  stata introdotta perch  abbastanza generale da catturare
  tutti i casi di cui l'attuale architettura abbisogna con un modesto impiego
  di risorse, mentre una soluzione pi parametrizzata (richiedendo calcoli
  esosi quale l'elaborazione delle possibili permutazioni di un numero
  variabile di elementi appartenenti ad un numero variabile di vettori)
  avrebbe inutilmente appesantito e rallentato il funzionamento del tool.

  <section|I constraint>

  <subsection|Due livelli di definizione: regole e sostituzioni>

  I constraint (o <em|vincoli>, o <em|condizioni>) possono essere definiti a
  due livelli:

  <\description>
    <expand|item*|a livello di una regola:>all'interno di un tag
    <verbatim|\<less\>rule\<gtr\>>, una serie di
    <verbatim|\<less\>constraints\<gtr\>> definisce le condizioni che
    attivano o meno tutte le sostituzioni contemplate da una regola, a meno
    di constraint non soddisfatti a livello delle singole sostituzioni;

    <expand|item*|a livello di una sostituzione:>all'interno di un tag
    <verbatim|\<less\>substitution\<gtr\>>, una serie di
    <verbatim|\<less\>constraints\<gtr\>> definisce le condizioni che
    attivano o meno una data sostituzione. Questo tipo di constraint viene
    valutato se e solo se quelli della regola a cui la sostituzione
    appartiene sono stati soddisfatti.
  </description>

  Questa distinzione, assieme alla possibilit di negare un vincolo, permette
  di ottenere un alto grado di flessibilit per le regole, e di accorpare
  insiemi di regole che differiscono solo per pochi aspetti.

  L'attributo <em|match=("any"\|"all")> dell'entit <em|constraints> indica
  se per l'applicazione di una regola  necessario che siano soddisfatti
  tutti i vincoli (<em|all>) oppure se basta che lo sia uno qualsiasi
  (<em|any>).

  Un vincolo deve essere espresso adottando una sintassi ben definita
  attraverso una delle forme predefinite.

  <subsection|Constraint predefiniti<label|constraint predefiniti>>

  I constraint predefiniti sono delle pseudo-funzioni introdotte per
  l'espressione di vincoli nei file delle regole. A quelli attualmente
  esistenti (<verbatim|equals>, <verbatim|isSet> e
  <verbatim|<verbatim|matchesRegExp>>), analizzati qui di seguito, 
  possibile aggiungerne di nuovi modificando la classe
  <em|it.uniroma2.XDGtoQLF.Constraint>.

  <verbatim|<paragraph|equals(a,b)>>

  E' soddisfatto se e solo se il valore di <verbatim|a>  uguale a quello di
  <verbatim|b>.

  Entrambi i parametri possono essere indifferentemente stringhe costanti o
  propriet.

  <verbatim|<paragraph|isSet(a)>>

  E' soddisfatto se la propriet <verbatim|a>  definita.

  Di fatto, il metodo <verbatim|XDGtoQLF.getFieldValue> viene invocato
  sull'oggetto in esame con la propriet indicata come argomento; qualsiasi
  valore di ritorno diverso da <verbatim|null> verifica la propriet. Il
  risultato <verbatim|null> pu essere restituito qualora la propriet
  indicata non esista, non sia inizializzata o non sia accessibile (si veda
  <reference|XDGtoQLFObject>).

  <verbatim|<paragraph|matchesRegExp(a,b)>>

  E' soddisfatto se la propriet <verbatim|a> dell'oggetto chiamante verifica
  l'espressione regolare rappresentata dal pattern <verbatim|b>.

  <subsection|Negazione dei constraint: forme condizionali per i file delle
  regole<label|negazione dei constraint>>

  Ogni constraint pu essere negato anteponendo all'espressione dello stesso
  un punto esclamativo (<verbatim|!>).

  Pertanto, il constraint <verbatim|!isSet([Head:Gov])> risulta soddisfatto
  se e solo se la sua forma non negata (<verbatim|isSet([Head:Gov])>) non lo
  .

  La negazione dei constraint permette di realizzare controlli di tipo
  <verbatim|if..else> nei file delle regole, come nel seguente esempio in cui
  se [la forma lemmatizzata de] il costituente in esame ha una <em|Named
  Entity Category> valida viene eseguita la prima sostituzione, altrimenti la
  seconda:

  <\with|color|blue>
    <\verbatim>
      <\code>
        <\with|font size|0.84>
          \ \ \ \ \ \ \<less\>substitutions\<gtr\>

          \ \ \ \ \ \ \ \ \<less\>substitution\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \<less\>tag\<gtr\>[Gov:LexHandleSequence:get(0):LemAlterVect:get(0):PNCategory]\<less\>/tag\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \<less\>constraints\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \ \ \<less\>constraint\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \ \ \ \ isSet([Gov:LexHandleSequence:get(0):LemAlterVect:get(0):PNCategory])

          \ \ \ \ \ \ \ \ \ \ \ \ \<less\>/constraint\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \<less\>/constraints\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \<less\>arguments\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \ \ \<less\>argument\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \ \ \ \ \<less\>label\<gtr\>e[Gov:Id]_0\<less\>/label\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \ \ \<less\>/argument\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \<less\>/arguments\<gtr\>

          \ \ \ \ \ \ \ \ \<less\>/substitution\<gtr\>

          \ \ \ \ \ \ \ \ \<less\>substitution\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \<less\>tag\<gtr\>'[Gov:Surface]'\<less\>/tag\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \<less\>constraints\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \ \ \<less\>constraint\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \ \ \ \ !isSet([Gov:LexHandleSequence:get(0):LemAlterVect:get(0):PNCategory])

          \ \ \ \ \ \ \ \ \ \ \ \ \<less\>/constraint\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \<less\>/constraints\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \<less\>arguments\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \ \ \<less\>argument\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \ \ \ \ \<less\>label\<gtr\>'[Gov:Surface]'\<less\>/label\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \ \ \<less\>/argument\<gtr\>

          \ \ \ \ \ \ \ \ \ \ \<less\>/arguments\<gtr\>

          \ \ \ \ \ \ \ \ \<less\>/substitution\<gtr\>

          \ \ \ \ \ \ \<less\>/substitutions\<gtr\>
        </with>
      </code>
    </verbatim>
  </with>
</body>

<\initial>
  <\collection>
    <associate|prog font|pandora>
    <associate|paragraph width|150mm>
    <associate|odd page margin|30mm>
    <associate|page right margin|30mm>
    <associate|page top margin|30mm>
    <associate|font|palatino>
    <associate|reduction page right margin|0mm>
    <associate|page type|a4>
    <associate|reduction page bottom margin|0mm>
    <associate|even page margin|30mm>
    <associate|reduction page left margin|0mm>
    <associate|page bottom margin|30mm>
    <associate|reduction page top margin|0mm>
    <associate|show header and footer|true>
    <associate|language|italian>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|file delle regole|<tuple|<uninit>|6>>
    <associate|toc-30|<tuple|4.1|13>>
    <associate|toc-10|<tuple|2|5>>
    <associate|toc-20|<tuple|3.4.1|8>>
    <associate|constraint predefiniti|<tuple|<uninit>|14>>
    <associate|toc-40|<tuple|5|15>>
    <associate|toc-50|<tuple|6.2|?>>
    <associate|toc-51|<tuple|6.2|?>>
    <associate|toc-31|<tuple|4.1|13>>
    <associate|toc-21|<tuple|3.4.2|8>>
    <associate|gly-1|<tuple|1|?>>
    <associate|toc-41|<tuple|5.1|15>>
    <associate|toc-11|<tuple|3|5>>
    <associate|toc-32|<tuple|4.1|13>>
    <associate|toc-42|<tuple|5.2|?>>
    <associate|gly-2|<tuple|2|?>>
    <associate|toc-12|<tuple|3.1|5>>
    <associate|toc-22|<tuple|3.4.3|8>>
    <associate|toc-52|<tuple|6.3|?>>
    <associate|toc-43|<tuple|5.3|?>>
    <associate|toc-33|<tuple|4.1|13>>
    <associate|toc-13|<tuple|3.1|5>>
    <associate|toc-23|<tuple|3.4.4|8>>
    <associate|toc-44|<tuple|5.3.1|?>>
    <associate|toc-34|<tuple|4.1|14>>
    <associate|toc-14|<tuple|3.1|5>>
    <associate|toc-24|<tuple|3.4.5|8>>
    <associate|toc-45|<tuple|5.3.2|?>>
    <associate|toc-25|<tuple|3.4.6|8>>
    <associate|toc-15|<tuple|3.1|5>>
    <associate|toc-35|<tuple|4.1|14>>
    <associate|toc-16|<tuple|3.2|7>>
    <associate|toc-36|<tuple|4.1|14>>
    <associate|toc-26|<tuple|3.4.6|9>>
    <associate|toc-46|<tuple|6|?>>
    <associate|toc-17|<tuple|3.2.1|7>>
    <associate|toc-27|<tuple|4|9>>
    <associate|toc-37|<tuple|4.1|14>>
    <associate|toc-47|<tuple|6.1|?>>
    <associate|toc-38|<tuple|4.1|14>>
    <associate|toc-18|<tuple|3.3|7>>
    <associate|toc-28|<tuple|4.1|9>>
    <associate|toc-48|<tuple|6.2|?>>
    <associate|toc-39|<tuple|4.1|14>>
    <associate|toc-29|<tuple|4.1|9>>
    <associate|toc-19|<tuple|3.4|7>>
    <associate|toc-49|<tuple|6.2|?>>
    <associate|regole|<tuple|<uninit>|8>>
    <associate|indicazione esplicita del file delle regole|<tuple|3|5>>
    <associate|footnote-1|<tuple|1|3>>
    <associate|footnote-2|<tuple|2|5>>
    <associate|footnote-3|<tuple|3|7>>
    <associate|footnote-4|<tuple|4|?>>
    <associate|grafo QLF|<tuple|2|4>>
    <associate|grafo XDG|<tuple|1|3>>
    <associate|XDGtoQLFObject|<tuple|3.4.1|7>>
    <associate|toc-1|<tuple|<uninit>|3>>
    <associate|toc-2|<tuple|1|3>>
    <associate|toc-3|<tuple|1.1|3>>
    <associate|toc-4|<tuple|1.2|3>>
    <associate|toc-5|<tuple|1.3|4>>
    <associate|toc-6|<tuple|1.4|4>>
    <associate|toc-7|<tuple|1.4.1|4>>
    <associate|toc-8|<tuple|1.4.2|4>>
    <associate|metodologie di confronto|<tuple|3.3.1|?>>
    <associate|toc-9|<tuple|1.4.2|5>>
    <associate|negazione dei constraint|<tuple|<uninit>|15>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|figure>
      <\tuple|normal>
        Struttura schematica di un grafo XDG.

        Con <with|font shape|<quote|italic>|I> sono indicati gli Icd, con
        <with|font shape|<quote|italic>|CC> i costituenti complessi e con
        <with|font shape|<quote|italic>|SC> i costituenti semplici.

        <with|font shape|<quote|italic>|H> e <with|font
        shape|<quote|italic>|G> sono le relazioni Head e Gov che legano le
        parti di un costituente complesso allo stesso.

        L'Head e il Gov di un costituente semplice sono lo stesso
        costituente.<label|grafo XDG>
      </tuple|<pageref|gly-1>>

      <\tuple|normal>
        Esempi di grafi QLF.

        Con <with|font shape|<quote|italic>|P> sono indicati i predicati,
        mentre gli argomenti sono indicati con <with|font
        shape|<quote|italic>|A>.

        Il grafo B non  ammissibile poich presenta un predicato annidato
        troppo in profondit.<label|grafo QLF>
      </tuple|<pageref|gly-2>>
    </associate>
    <\associate|toc>
      <vspace*|2fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|font size|<quote|1.19>|Introduzione><value|toc-dots><pageref|toc-1><vspace|1fn>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|1<space|2spc>Scopo del
      progetto><value|toc-dots><pageref|toc-2><vspace|0.5fn>

      1.1<space|2spc>XDG<value|toc-dots><pageref|toc-3>

      1.2<space|2spc>QLF<value|toc-dots><pageref|toc-4>

      1.3<space|2spc>XDG <with|mode|<quote|math>|\<longmapsto\>>
      QLF<value|toc-dots><pageref|toc-5>

      1.4<space|2spc>Vincoli progettuali<value|toc-dots><pageref|toc-6>

      <with|left margin|<quote|1.5fn>|1.4.1<space|2spc>Vincoli sulla capacit
      espressiva delle regole<value|toc-dots><pageref|toc-7>>

      <with|left margin|<quote|1.5fn>|1.4.2<space|2spc>Vincoli
      implementativi<value|toc-dots><pageref|toc-8>>

      <vspace*|2fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|font size|<quote|1.19>|La soluzione proposta:
      XDGtoQLF><value|toc-dots><pageref|toc-9><vspace|1fn>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|2<space|2spc>Una descrizione ad alto
      livello><value|toc-dots><pageref|toc-10><vspace|0.5fn>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|3<space|2spc>Aspetti
      implementativi><value|toc-dots><pageref|toc-11><vspace|0.5fn>

      3.1<space|2spc>Tecnologie adottate<value|toc-dots><pageref|toc-12>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|XML<value|toc-dots><pageref|toc-13>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|Java<value|toc-dots><pageref|toc-14>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|XML
      <with|mode|<quote|math>|\<Longleftrightarrow\>> Java: <with|font
      shape|<quote|italic>|fr.ernstb.xmlcode><value|toc-dots><pageref|toc-15>>

      3.2<space|2spc>Algoritmi adottati<value|toc-dots><pageref|toc-16>

      <with|left margin|<quote|1.5fn>|3.2.1<space|2spc>Comportamento di alto
      livello del sistema<value|toc-dots><pageref|toc-17>>

      3.3<space|2spc>Organizzazione del filesystem<value|toc-dots><pageref|toc-18>

      3.4<space|2spc>Classi principali<value|toc-dots><pageref|toc-19>

      <with|left margin|<quote|1.5fn>|3.4.1<space|2spc>XDGtoQLFObject<value|toc-dots><pageref|toc-20>>

      <with|left margin|<quote|1.5fn>|3.4.2<space|2spc>XDGtoQLF<value|toc-dots><pageref|toc-21>>

      <with|left margin|<quote|1.5fn>|3.4.3<space|2spc>Rule<value|toc-dots><pageref|toc-22>>

      <with|left margin|<quote|1.5fn>|3.4.4<space|2spc>ListOfConstraints<value|toc-dots><pageref|toc-23>>

      <with|left margin|<quote|1.5fn>|3.4.5<space|2spc>Constraint<value|toc-dots><pageref|toc-24>>

      <with|left margin|<quote|1.5fn>|3.4.6<space|2spc>Substitution<value|toc-dots><pageref|toc-25>>

      <vspace*|2fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|font size|<quote|1.19>|I file delle
      regole<label|regole>><value|toc-dots><pageref|toc-26><vspace|1fn>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|4<space|2spc>Struttura di un file di
      regole><value|toc-dots><pageref|toc-27><vspace|0.5fn>

      4.1<space|2spc>Xml Schema Definition per i file delle
      regole<value|toc-dots><pageref|toc-28>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|Schema
      definition<value|toc-dots><pageref|toc-29>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
      <with|color|<quote|blue>|\<less\>rules\<gtr\>><value|toc-dots><pageref|toc-30>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
      <with|color|<quote|blue>|\<less\>constituents\<gtr\>> e
      <with|color|<quote|blue>|\<less\>icds\<gtr\>><value|toc-dots><pageref|toc-31>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
      <with|color|<quote|blue>|\<less\>rule\<gtr\>><value|toc-dots><pageref|toc-32>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
      <with|color|<quote|blue>|\<less\>constraints\<gtr\>><value|toc-dots><pageref|toc-33>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
      <with|color|<quote|blue>|\<less\>substitutions\<gtr\>><value|toc-dots><pageref|toc-34>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
      <with|color|<quote|blue>|\<less\>constraint\<gtr\>><value|toc-dots><pageref|toc-35>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
      <with|color|<quote|blue>|\<less\>substitution\<gtr\>><value|toc-dots><pageref|toc-36>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
      <with|color|<quote|blue>|\<less\>arguments\<gtr\>><value|toc-dots><pageref|toc-37>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|Entit
      <with|color|<quote|blue>|\<less\>argument\<gtr\>><value|toc-dots><pageref|toc-38>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|Chiusura della
      definizione<value|toc-dots><pageref|toc-39>>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|5<space|2spc>Propriet, costanti ed espansione dei
      predicati mediante EuroWordNet><value|toc-dots><pageref|toc-40><vspace|0.5fn>

      5.1<space|2spc>Stringhe costanti<value|toc-dots><pageref|toc-41>

      5.2<space|2spc>Propriet<value|toc-dots><pageref|toc-42>

      5.3<space|2spc>Espansione dei predicati generati mediante
      EoroWordNet<value|toc-dots><pageref|toc-43>

      <with|left margin|<quote|1.5fn>|5.3.1<space|2spc>Il concetto di
      <with|font shape|<quote|italic>|espansione><value|toc-dots><pageref|toc-44>>

      <with|left margin|<quote|1.5fn>|5.3.2<space|2spc>Parole chiave per
      l'espansione dei predicati<value|toc-dots><pageref|toc-45>>

      <vspace*|1fn><with|font series|<quote|bold>|math font
      series|<quote|bold>|6<space|2spc>I constraint><value|toc-dots><pageref|toc-46><vspace|0.5fn>

      6.1<space|2spc>Due livelli di definizione: regole e
      sostituzioni<value|toc-dots><pageref|toc-47>

      6.2<space|2spc>Constraint predefiniti<label|constraint
      predefiniti><value|toc-dots><pageref|toc-48>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|equals(a,b)<value|toc-dots><pageref|toc-49>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|isSet(a)<value|toc-dots><pageref|toc-50>>

      <with|left margin|<quote|6fn>|font size|<quote|0.84>|matchesRegExp(a,b)<value|toc-dots><pageref|toc-51>>

      6.3<space|2spc>Negazione dei constraint: forme condizionali per i file
      delle regole<label|negazione dei constraint><value|toc-dots><pageref|toc-52>
    </associate>
  </collection>
</auxiliary>
